from datetime import date


AUTHOR = "Julien Palard"
SITENAME = "mdk.fr"
SITETITLE = "Julien Palard"
SITESUBTITLE = "Développeur et formateur Python"
SITEURL = ""
SITELOGO = "/images/julien.jpg"
SITEDESCRIPTION = "Julien Palard, formateur Python"
ROBOTS = "index, follow"
COPYRIGHT_NAME = "Julien Palard"
COPYRIGHT_YEAR = str(date.today().year)
HOME_HIDE_TAGS = False
DISABLE_URL_HASH = True
FAVICON = "/images/favicon.png"

DISPLAY_PAGES_ON_MENU = False
MAIN_MENU = True

MENUITEMS = (
    ("Formations", "/pages/formations.html"),
    ("Conférences", "/pages/talks.html"),
    ("Articles", "/blog/"),
)

LINKS = (
)

# Social widget
SOCIAL = (
    ("mastodon", "https://mamot.fr/@mdk"),
    ("github", "https://github.com/julienpalard"),
    ("stack-overflow", "https://stackoverflow.com/users/232831/julien-palard"),
    ("rss", "/feeds/all.atom.xml"),
)

# Path to Plugins
PLUGIN_PATHS = ['pelican-plugins']
# Enable i18n plugin, probably you already have some others here.
PLUGINS = ['i18n_subsites', 'filetime_from_git', 'gzip_cache']
# Enable Jinja2 i18n extension used to parse translations.
JINJA_ENVIRONMENT = {'extensions': ['jinja2.ext.i18n']}
I18N_TEMPLATES_LANG = "en"

# Match languages for other configs.
OG_LOCALE = "fr_FR"
LOCALE = ("fr_FR", "fr_FR.utf8")

# Your language.
DEFAULT_LANG = "fr_FR"

I18N_SUBSITES = {
    'en': {
        'LOCALE': 'en_US',
        'THEME_STATIC_DIR': '../theme',
        'SITESUBTITLE': "Freelance Python Programmer and Trainer",
        'MENUITEMS': (
            ("Trainings", "/en/pages/formations.html"),
            ("Talks", "/en/pages/talks.html"),
            ("Articles", "/en/blog/"),
        )
    }
}

PATH = "content"

TIMEZONE = "Europe/Paris"

DEFAULT_LANG = "fr"

# Feed generation is usually not desired when developing
FEED_ALL_ATOM = None
CATEGORY_FEED_ATOM = None
TRANSLATION_FEED_ATOM = None
AUTHOR_FEED_ATOM = None
AUTHOR_FEED_RSS = None

THEME_COLOR = "light"
THEME_COLOR_AUTO_DETECT_BROWSER_PREFERENCE = True
THEME_COLOR_ENABLE_USER_OVERRIDE = False

PYGMENTS_STYLE = "emacs"
PYGMENTS_STYLE_DARK = "monokai"

USE_GOOGLE_FONTS = False
DEFAULT_PAGINATION = 10
THEME = "Flex"
THEME_STATIC_DIR = "theme"
THEME_TEMPLATES_OVERRIDES = ['templates/']
ARTICLE_URL = "{category}/{slug}.html"
STATIC_PATHS = ["images"]

ARTICLE_SAVE_AS = "{category}/{slug}.html"
CATEGORY_URL = "{slug}/"
CATEGORY_SAVE_AS = "{slug}/index.html"

# Uncomment following line if you want document-relative URLs when developing
# RELATIVE_URLS = True
